public ActionResult DemographicsExcelDocument(int SurveyNumber, int Demographic, SurveyDefinition survey)
{
	using (ExcelEngine excelEngine = new ExcelEngine())
	{
		string CompanyName = survey.GetCompany(SurveyNumber);
		string CompanyNoSpaceName = CompanyName.Replace(" ", "_");
		string demo = survey.GetQuestionText(Demographic);
		int NumberPossibleResponses = survey.NumberDemographicResponses(Demographic);
		string alpha = "";
		switch(NumberPossibleResponses)
		{
			case 2:
				alpha = "C";
				break;
			case 3:
				alpha = "D";
				break;
			case 4:
				alpha = "E";
				break;
			case 5:
				alpha = "F";
				break;
			case 6:
				alpha = "G";
				break;
			case 7:
				alpha = "H";
				break;
			case 8:
				alpha = "I";
				break;
			case 9:
				alpha = "J";
				break;
			case 10:
				alpha = "K";
				break;
		}

		// Set the default application version as Excel 2016.
		excelEngine.Excel.DefaultVersion = ExcelVersion.Excel2016;

		// Create a workbook with a worksheet.
		IWorkbook workbook = excelEngine.Excel.Workbooks.Create(new string[] { "Q1", "Q4", "Q5", "Q7", "Q8", "Q9", "Q11", "Q12", "Q15", "Q17", "Q18", "Category Rank Comparison", "Rate Strongly Agree", "Rate Strongly Disagree" });

		//-------------------------------------------------------------------------------------------------------------Q1
		IWorksheet sheet0 = workbook.Worksheets[0];
		sheet0.Range["A1"].Text = "Attitudes & Perceptions";
		sheet0.Range["A1"].CellStyle.Font.Bold = true;
		sheet0.Range["A1"].CellStyle.Font.Size = 18;


		IList<ChartData> data0 = survey.PivotedDemographics(1, SurveyNumber, Demographic, NumberPossibleResponses);
		sheet0.ImportData(data0, 3, 1, false);
		//IChartShape chart0 = sheet0.Charts.Add();
		//chart0.ChartType = ExcelChartType.Bar_Clustered;
		int lastrow = Convert.ToInt16(sheet0.UsedRange.LastRow);
		int rownum = lastrow + 2;
		int numRows = survey.CountMatrixQuestions(SurveyNumber, 1);
		int c = (numRows * 6) + rownum;
		//chart0.DataRange = sheet0.Range["A3:" + alpha + lastrow.ToString()];
		//chart0.PrimaryValueAxis.MinimumValue = 0;
		//chart0.PrimaryValueAxis.MaximumValue = 5.5;
		//chart0.PrimaryValueAxis.MajorUnit = .5;
		//chart0.PrimaryValueAxis.Title = "Average Answer";
		//chart0.ChartTitle = "";
		//chart0.IsSeriesInRows = false;
		//chart0.Legend.Position = ExcelLegendPosition.Bottom;
		//chart0.TopRow = 3;
		//chart0.BottomRow = c;
		//chart0.LeftColumn = 1;
		//chart0.RightColumn = 15;


		//-------------------------------------------------------------------------------------------------------------Q4
		IWorksheet sheet1 = workbook.Worksheets[1];
		sheet1.Range["A1"].Text = "Roles & Responsibilites";
		sheet1.Range["A1"].CellStyle.Font.Bold = true;
		sheet1.Range["A1"].CellStyle.Font.Size = 18;
		IList<ChartData> data1 = survey.PivotedDemographics(4, SurveyNumber, Demographic, NumberPossibleResponses);
		sheet1.ImportData(data1, 3, 1, false);
		IChartShape chart1 = sheet1.Charts.Add();
		chart1.ChartType = ExcelChartType.Bar_Clustered;
		lastrow = Convert.ToInt16(sheet1.UsedRange.LastRow);
		rownum = lastrow + 2;
		numRows = survey.CountMatrixQuestions(SurveyNumber, 4);
		c = (numRows * 6) + rownum;
		chart1.DataRange = sheet1.Range["A3:" + alpha + lastrow.ToString()];
		chart1.PrimaryValueAxis.MinimumValue = 0;
		chart1.PrimaryValueAxis.MaximumValue = 5.5;
		chart1.PrimaryValueAxis.MajorUnit = .5;
		chart1.PrimaryValueAxis.Title = "Average Answer";
		chart1.ChartTitle = "";
		chart1.IsSeriesInRows = false;
		chart1.Legend.Position = ExcelLegendPosition.Bottom;
		chart1.TopRow = 3;
		chart1.BottomRow = c;
		chart1.LeftColumn = 1;
		chart1.RightColumn = 15;

		//-------------------------------------------------------------------------------------------------------------Q5
		IWorksheet sheet2 = workbook.Worksheets[2];
		sheet2.Range["A1"].Text = "Client Engagement";
		sheet2.Range["A1"].CellStyle.Font.Bold = true;
		sheet2.Range["A1"].CellStyle.Font.Size = 18;
		IList<ChartData> data2 = survey.PivotedDemographics(5, SurveyNumber, Demographic, NumberPossibleResponses);
		sheet2.ImportData(data2, 3, 1, false);
		IChartShape chart2 = sheet2.Charts.Add();
		chart2.ChartType = ExcelChartType.Bar_Clustered;
		lastrow = Convert.ToInt16(sheet2.UsedRange.LastRow);
		rownum = lastrow + 2;
		numRows = survey.CountMatrixQuestions(SurveyNumber, 5);
		c = (numRows * 6) + rownum;
		chart2.DataRange = sheet2.Range["A3:" + alpha + lastrow.ToString()];
		chart2.PrimaryValueAxis.MinimumValue = 0;
		chart2.PrimaryValueAxis.MaximumValue = 5.5;
		chart2.PrimaryValueAxis.MajorUnit = .5;
		chart2.PrimaryValueAxis.Title = "Average Answer";
		chart2.ChartTitle = "";
		chart2.IsSeriesInRows = false;
		chart2.Legend.Position = ExcelLegendPosition.Bottom;
		chart2.TopRow = 3;
		chart2.BottomRow = c;
		chart2.LeftColumn = 1;
		chart2.RightColumn = 15;


		//-------------------------------------------------------------------------------------------------------------Q7
		IWorksheet sheet3 = workbook.Worksheets[3];
		sheet3.Range["A1"].Text = "Physical Space";
		sheet3.Range["A1"].CellStyle.Font.Bold = true;
		sheet3.Range["A1"].CellStyle.Font.Size = 18;
		IList<ChartData> data3 = survey.PivotedDemographics(7, SurveyNumber, Demographic, NumberPossibleResponses);
		sheet3.ImportData(data3, 3, 1, false);
		IChartShape chart3 = sheet3.Charts.Add();
		chart3.ChartType = ExcelChartType.Bar_Clustered;
		lastrow = Convert.ToInt16(sheet3.UsedRange.LastRow);
		rownum = lastrow + 2;
		numRows = survey.CountMatrixQuestions(SurveyNumber, 7);
		c = (numRows * 6) + rownum;
		chart3.DataRange = sheet3.Range["A3:" + alpha + lastrow.ToString()];
		chart3.PrimaryValueAxis.MinimumValue = 0;
		chart3.PrimaryValueAxis.MaximumValue = 5.5;
		chart3.PrimaryValueAxis.MajorUnit = .5;
		chart3.PrimaryValueAxis.Title = "Average Answer";
		chart3.ChartTitle = "";
		chart3.IsSeriesInRows = false;
		chart3.Legend.Position = ExcelLegendPosition.Bottom;
		chart3.TopRow = 3;
		chart3.BottomRow = c;
		chart3.LeftColumn = 1;
		chart3.RightColumn = 15;

		//-------------------------------------------------------------------------------------------------------------Q8
		IWorksheet sheet4 = workbook.Worksheets[4];
		sheet4.Range["A1"].Text = "Collaboration";
		sheet4.Range["A1"].CellStyle.Font.Bold = true;
		sheet4.Range["A1"].CellStyle.Font.Size = 18;
		IList<ChartData> data4 = survey.PivotedDemographics(8, SurveyNumber, Demographic, NumberPossibleResponses);
		sheet4.ImportData(data4, 3, 1, false);
		IChartShape chart4 = sheet4.Charts.Add();
		chart4.ChartType = ExcelChartType.Bar_Clustered;
		lastrow = Convert.ToInt16(sheet4.UsedRange.LastRow);
		rownum = lastrow + 2;
		numRows = survey.CountMatrixQuestions(SurveyNumber, 8);
		c = (numRows * 6) + rownum;
		chart4.DataRange = sheet4.Range["A3:" + alpha + lastrow.ToString()];
		chart4.PrimaryValueAxis.MinimumValue = 0;
		chart4.PrimaryValueAxis.MaximumValue = 5.5;
		chart4.PrimaryValueAxis.MajorUnit = .5;
		chart4.PrimaryValueAxis.Title = "Average Answer";
		chart4.ChartTitle = "";
		chart4.IsSeriesInRows = false;
		chart4.Legend.Position = ExcelLegendPosition.Bottom;
		chart4.TopRow = 3;
		chart4.BottomRow = c;
		chart4.LeftColumn = 1;
		chart4.RightColumn = 15;

		//-------------------------------------------------------------------------------------------------------------Q9
		IWorksheet sheet5 = workbook.Worksheets[5];
		sheet5.Range["A1"].Text = "Idea Sharing";
		sheet5.Range["A1"].CellStyle.Font.Bold = true;
		sheet5.Range["A1"].CellStyle.Font.Size = 18;
		IList<ChartData> data5 = survey.PivotedDemographics(9, SurveyNumber, Demographic, NumberPossibleResponses);
		sheet5.ImportData(data5, 3, 1, false);
		IChartShape chart5 = sheet5.Charts.Add();
		chart5.ChartType = ExcelChartType.Bar_Clustered;
		lastrow = Convert.ToInt16(sheet5.UsedRange.LastRow);
		rownum = lastrow + 2;
		numRows = survey.CountMatrixQuestions(SurveyNumber, 9);
		c = (numRows * 6) + rownum;
		chart5.DataRange = sheet5.Range["A3:" + alpha + lastrow.ToString()];
		chart5.PrimaryValueAxis.MinimumValue = 0;
		chart5.PrimaryValueAxis.MaximumValue = 5.5;
		chart5.PrimaryValueAxis.MajorUnit = .5;
		chart5.PrimaryValueAxis.Title = "Average Answer";
		chart5.ChartTitle = "";
		chart5.IsSeriesInRows = false;
		chart5.Legend.Position = ExcelLegendPosition.Bottom;
		chart5.TopRow = 3;
		chart5.BottomRow = c;
		chart5.LeftColumn = 1;
		chart5.RightColumn = 15;

		//-------------------------------------------------------------------------------------------------------------Q11
		IWorksheet sheet6 = workbook.Worksheets[6];
		sheet6.Range["A1"].Text = "Leadership Direction & Engagement";
		sheet6.Range["A1"].CellStyle.Font.Bold = true;
		sheet6.Range["A1"].CellStyle.Font.Size = 18;
		IList<ChartData> data6 = survey.PivotedDemographics(11, SurveyNumber, Demographic, NumberPossibleResponses);
		sheet6.ImportData(data6, 3, 1, false);
		IChartShape chart6 = sheet6.Charts.Add();
		chart6.ChartType = ExcelChartType.Bar_Clustered;
		lastrow = Convert.ToInt16(sheet6.UsedRange.LastRow);
		rownum = lastrow + 2;
		numRows = survey.CountMatrixQuestions(SurveyNumber, 11);
		c = (numRows * 6) + rownum;
		chart6.DataRange = sheet0.Range["A3:" + alpha + lastrow.ToString()];
		chart6.PrimaryValueAxis.MinimumValue = 0;
		chart6.PrimaryValueAxis.MaximumValue = 5.5;
		chart6.PrimaryValueAxis.MajorUnit = .5;
		chart6.PrimaryValueAxis.Title = "Average Answer";
		chart6.ChartTitle = "";
		chart6.IsSeriesInRows = false;
		chart6.Legend.Position = ExcelLegendPosition.Bottom;
		chart6.TopRow = 3;
		chart6.BottomRow = c;
		chart6.LeftColumn = 1;
		chart6.RightColumn = 15;

		//-------------------------------------------------------------------------------------------------------------Q12
		IWorksheet sheet7 = workbook.Worksheets[7];
		sheet7.Range["A1"].Text = "Communication Quality & Frequency";
		sheet7.Range["A1"].CellStyle.Font.Bold = true;
		sheet7.Range["A1"].CellStyle.Font.Size = 18;
		IList<ChartData> data7 = survey.PivotedDemographics(12, SurveyNumber, Demographic, NumberPossibleResponses);
		sheet7.ImportData(data7, 3, 1, false);
		IChartShape chart7 = sheet7.Charts.Add();
		chart7.ChartType = ExcelChartType.Bar_Clustered;
		lastrow = Convert.ToInt16(sheet7.UsedRange.LastRow);
		rownum = lastrow + 2;
		numRows = survey.CountMatrixQuestions(SurveyNumber, 12);
		c = (numRows * 6) + rownum;
		chart7.DataRange = sheet0.Range["A3:" + alpha + lastrow.ToString()];
		chart7.PrimaryValueAxis.MinimumValue = 0;
		chart7.PrimaryValueAxis.MaximumValue = 5.5;
		chart7.PrimaryValueAxis.MajorUnit = .5;
		chart7.PrimaryValueAxis.Title = "Average Answer";
		chart7.ChartTitle = "";
		chart7.IsSeriesInRows = false;
		chart7.Legend.Position = ExcelLegendPosition.Bottom;
		chart7.TopRow = 3;
		chart7.BottomRow = c;
		chart7.LeftColumn = 1;
		chart7.RightColumn = 15;

		//-------------------------------------------------------------------------------------------------------------Q15
		IWorksheet sheet8 = workbook.Worksheets[8];
		sheet8.Range["A1"].Text = "Vision & Values";
		sheet8.Range["A1"].CellStyle.Font.Bold = true;
		sheet8.Range["A1"].CellStyle.Font.Size = 18;
		IList<ChartData> data8 = survey.PivotedDemographics(15, SurveyNumber, Demographic, NumberPossibleResponses);
		sheet8.ImportData(data8, 3, 1, false);
		IChartShape chart8 = sheet8.Charts.Add();
		chart8.ChartType = ExcelChartType.Bar_Clustered;
		lastrow = Convert.ToInt16(sheet8.UsedRange.LastRow);
		rownum = lastrow + 2;
		numRows = survey.CountMatrixQuestions(SurveyNumber, 15);
		c = (numRows * 6) + rownum;
		chart8.DataRange = sheet0.Range["A3:" + alpha + lastrow.ToString()];
		chart8.PrimaryValueAxis.MinimumValue = 0;
		chart8.PrimaryValueAxis.MaximumValue = 5.5;
		chart8.PrimaryValueAxis.MajorUnit = .5;
		chart8.PrimaryValueAxis.Title = "Average Answer";
		chart8.ChartTitle = "";
		chart8.IsSeriesInRows = false;
		chart8.Legend.Position = ExcelLegendPosition.Bottom;
		chart8.TopRow = 3;
		chart8.BottomRow = c;
		chart8.LeftColumn = 1;
		chart8.RightColumn = 15;

		//-------------------------------------------------------------------------------------------------------------Q17
		IWorksheet sheet9 = workbook.Worksheets[9];
		sheet9.Range["A1"].Text = "Support & Development";
		sheet9.Range["A1"].CellStyle.Font.Bold = true;
		sheet9.Range["A1"].CellStyle.Font.Size = 18;
		IList<ChartData> data9 = survey.PivotedDemographics(17, SurveyNumber, Demographic, NumberPossibleResponses);
		sheet9.ImportData(data9, 3, 1, false);
		IChartShape chart9 = sheet9.Charts.Add();
		chart9.ChartType = ExcelChartType.Bar_Clustered;
		lastrow = Convert.ToInt16(sheet9.UsedRange.LastRow);
		rownum = lastrow + 2;
		numRows = survey.CountMatrixQuestions(SurveyNumber, 17);
		c = (numRows * 6) + rownum;
		chart9.DataRange = sheet0.Range["A3:" + alpha + lastrow.ToString()];
		chart9.PrimaryValueAxis.MinimumValue = 0;
		chart9.PrimaryValueAxis.MaximumValue = 5.5;
		chart9.PrimaryValueAxis.MajorUnit = .5;
		chart9.PrimaryValueAxis.Title = "Average Answer";
		chart9.ChartTitle = "";
		chart9.IsSeriesInRows = false;
		chart9.Legend.Position = ExcelLegendPosition.Bottom;
		chart9.TopRow = 3;
		chart9.BottomRow = c;
		chart9.LeftColumn = 1;
		chart9.RightColumn = 15;

		//-------------------------------------------------------------------------------------------------------------Q18
		IWorksheet sheet10 = workbook.Worksheets[10];
		sheet10.Range["A1"].Text = "Reward & Recognition";
		sheet10.Range["A1"].CellStyle.Font.Bold = true;
		sheet10.Range["A1"].CellStyle.Font.Size = 18;
		IList<ChartData> data10 = survey.PivotedDemographics(18, SurveyNumber, Demographic, NumberPossibleResponses);
		sheet10.ImportData(data10, 3, 1, false);
		IChartShape chart10 = sheet10.Charts.Add();
		chart10.ChartType = ExcelChartType.Bar_Clustered;
		lastrow = Convert.ToInt16(sheet10.UsedRange.LastRow);
		rownum = lastrow + 2;
		numRows = survey.CountMatrixQuestions(SurveyNumber, 18);
		c = (numRows * 6) + rownum;
		chart10.DataRange = sheet0.Range["A3:" + alpha + lastrow.ToString()];
		chart10.PrimaryValueAxis.MinimumValue = 0;
		chart10.PrimaryValueAxis.MaximumValue = 5.5;
		chart10.PrimaryValueAxis.MajorUnit = .5;
		chart10.PrimaryValueAxis.Title = "Average Answer";
		chart10.ChartTitle = "";
		chart10.IsSeriesInRows = false;
		chart10.Legend.Position = ExcelLegendPosition.Bottom;
		chart10.TopRow = 3;
		chart10.BottomRow = c;
		chart10.LeftColumn = 1;
		chart10.RightColumn = 15;

		// -------------------------------------------------------------------------------------------------------------Category Rank Comparison
		IWorksheet sheet11 = workbook.Worksheets[11];
		sheet11.Range["A1"].Text = "Category Rank Comparison";
		sheet11.Range["A1"].CellStyle.Font.Bold = true;
		sheet11.Range["A1"].CellStyle.Font.Size = 18;

		// -------------------------------------------------------------------------------------------------------------Rate For Strongly Agree
		IWorksheet sheet12 = workbook.Worksheets[12];
		sheet12.Range["A1"].Text = "Rate for Strongly Agree";
		sheet12.Range["A1"].CellStyle.Font.Bold = true;
		sheet12.Range["A1"].CellStyle.Font.Size = 18;

		// -------------------------------------------------------------------------------------------------------------Rate For Strongly Disagree
		IWorksheet sheet13 = workbook.Worksheets[13];
		sheet13.Range["A1"].Text = "Rate for Strongly Disagree";
		sheet13.Range["A1"].CellStyle.Font.Bold = true;
		sheet13.Range["A1"].CellStyle.Font.Size = 18;



		workbook.SaveAs(CompanyNoSpaceName + "_Demographic.xlsx", HttpContext.ApplicationInstance.Response, ExcelDownloadType.PromptDialog);
		workbook.Close();
		excelEngine.Dispose();
	}
	return View();
}